package org.jvnet.hifaces.application.navigation.impl;

import javax.faces.context.FacesContext;
import javax.servlet.ServletRequest;

public class NavigationBean {

	public String reload() {
		return DefaultNavigator.RELOAD_OUTCOME;
	}

	public String previous() {
		return DefaultNavigator.PREVIOUS_OUTCOME;
	}

	public String next() {
		return DefaultNavigator.NEXT_OUTCOME;
	}

	public State getCurrentState() {
		final FacesContext facesContext = FacesContext.getCurrentInstance();
		if (facesContext != null) {
			final ServletRequest request = (ServletRequest) facesContext
					.getExternalContext().getRequest();
			final State currentState = (State) request
					.getAttribute(DefaultNavigator.CURRENT_STATE_REQUEST_ATTRIBUTE_NAME);
			return currentState;
		} else {
			return null;
		}
	}

	public boolean isCurrentAvailable() {
		final State currentState = getCurrentState();
		return currentState != null;

	}

	public boolean isPreviousAvailable() {
		final State currentState = getCurrentState();
		if (currentState != null) {
			return currentState.isPreviousAvailable();
		} else {
			return false;
		}
	}

	public boolean isNextAvailable() {
		final State currentState = getCurrentState();
		if (currentState != null) {
			return currentState.isNextAvailable();
		} else {
			return false;
		}
	}
}
