package org.jvnet.hifaces.components.templatedpanel;

import javax.faces.component.html.HtmlPanelGroup;
import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;
import javax.faces.render.Renderer;

import org.jvnet.hifaces.components.templatedpanel.impl.DefaultTemplateProviderFactory;

public class AbstractTemplatedPanel extends HtmlPanelGroup {

	private String templateName = null;

	public void setTemplateName(String template) {
		this.templateName = template;
	}

	public String getTemplateName() {
		if (templateName != null)
			return templateName;
		final ValueBinding vb = getValueBinding("template");
		return vb != null ? (String) vb.getValue(getFacesContext()) : null;
	}

	public Object saveState(FacesContext context) {
		Object values[] = new Object[3];
		values[0] = super.saveState(context);
		values[1] = templateName;
		return ((Object) (values));
	}

	public void restoreState(FacesContext context, Object state) {
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		templateName = (String) values[1];
	}

	private TemplateProviderFactory templateProviderFactory;

	public void setTemplateProviderFactory(
			TemplateProviderFactory templateProviderFactory) {
		this.templateProviderFactory = templateProviderFactory;
	}

	public TemplateProviderFactory getTemplateProviderFactory() {
		if (templateProviderFactory == null) {
			templateProviderFactory = DefaultTemplateProviderFactory
					.getInstance(getFacesContext());
		}
		return templateProviderFactory;
	}

	private TemplateProvider templateProvider;

	public void setTemplateProvider(TemplateProvider templateProvider) {
		this.templateProvider = templateProvider;
	}

	public TemplateProvider getTemplateProvider() {
		if (templateProvider != null) {
			return templateProvider;
		} else {
			final ValueBinding vb = getValueBinding("templateProvider");
			if (vb != null) {
				return (TemplateProvider) vb.getValue(getFacesContext());
			} else {
				final TemplateProviderFactory templateProviderFactory = getTemplateProviderFactory();
				final TemplateProvider templateProvider = templateProviderFactory
						.getTemplateProvider(getFacesContext());
				return templateProvider;
			}
		}
	}

	protected Template getTemplate(final String templateName,
			final String fragmentId) throws Exception {
		final TemplateProvider templateProvider = getTemplateProvider();
		final Template template = templateProvider.getTemplate(
				getFacesContext(), templateName, fragmentId);
		return template;
	}
}
