package org.jvnet.hifaces.components.templatedpanel.impl;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URLConnection;

import org.w3c.dom.Element;
import org.xml.sax.SAXException;

public class FileTemplateResource implements TemplateResource {

	private final File file;

	public FileTemplateResource(final File url) {
		this.file = url;
	}

	public String getKey() {
		return file.getAbsolutePath();
	}

	public Element getAsDomElement() throws IOException, SAXException {
		InputStream is = null;
		try {
			is = new BufferedInputStream(new FileInputStream(file));
			return ParseUtilities.parse(is);
		} finally {
			if (is != null) {
				try {
					is.close();
				} catch (IOException ex) {
					// Ignore the exception;
				}
			}

		}
	}

	public long getLastModified() throws IOException {
		return file.lastModified();
	}

}
