package org.jvnet.hifaces.function.util;

import java.lang.reflect.Method;

import org.apache.commons.beanutils.MethodUtils;
import org.apache.commons.lang.ArrayUtils;

public class FunctionUtils {

	private FunctionUtils() {

	}

	public static String capitalize(String name) {
		if (name == null || name.length() == 0) {
			return name;
		}
		return name.substring(0, 1).toUpperCase() + name.substring(1);
	}

	public static Method getter(Class clazz, String name) {
		return getter(clazz, name, (Class[]) null);
	}

	public static Method getter(Class clazz, String name, Class[] args) {
		final Method get = MethodUtils.getAccessibleMethod(clazz, "get"
				+ capitalize(name), args);
		if (get != null) {
			return get;
		} else {
			return MethodUtils.getAccessibleMethod(clazz, "is"
					+ capitalize(name), args);
		}
	}

	public static Method setter(Class clazz, String name, Class argumentClass) {
		return setter(clazz, name, (Class[]) null, argumentClass);
	}

	public static Method setter(Class clazz, String name, Class[] arguments,
			Class argumentClass) {

		final Class[] args = (Class[]) ArrayUtils.addAll(arguments,
				new Class[] { argumentClass });
		return MethodUtils.getMatchingAccessibleMethod(clazz, "set"
				+ capitalize(name), args);
	}

}
