package org.jvnet.hifaces.model.paging;

import java.util.List;

/**
 * Data page represents a chunk of larger data array. It incapsulates a list of
 * elements representing the subsequence, starting index of this subsequence as
 * well as number of elements of the main sequence.
 * 
 * @author valikov
 * @param <T>
 *            Type of the entry.
 */
public interface DataPage<T> {

	/**
	 * Starting index.
	 * 
	 * @return Starting index.
	 */
	public int getStart();

	/**
	 * Number of elements in the main data array.
	 * 
	 * @return Number of elements in the main data array.
	 */
	public int getCount();

	/**
	 * Elements of the page.
	 * 
	 * @return List of elements of the page.
	 */
	public List<T> getData();

}
