/*
 * Copyright (c) 1998-2006 TeamDev Ltd. All Rights Reserved.
 * Use is subject to license terms.
 */

//------------------------------------------------------------------------------------------------------------------
function d_getElementLeft(elt, ignoreAbsolutePosition)
{
  var left = 0;
  if (elt != null && (elt.style.position != "absolute" && d_calculateStyleProperty(elt, "position") != "absolute" || ignoreAbsolutePosition)) {
    left = elt.offsetLeft;
    if (d_isExplorer() || d_isOpera()) {
      var lowerCaseTagName = elt.tagName.toLowerCase();
      if (lowerCaseTagName == 'table') {
        if (elt.border > 0) {
          left ++;
        }
      } else if (lowerCaseTagName == 'div' || lowerCaseTagName == 'td') {
        left += elt.clientLeft;
      }
    }
    if (elt.offsetParent) {
      var parentLeft = d_getElementLeft(elt.offsetParent, ignoreAbsolutePosition);
      left += parentLeft;
    }
  }
  return left;
}
//------------------------------------------------------------------------------------------------------------------
function d_getControl(id)
{
  return document.getElementById(id);
}
//------------------------------------------------------------------------------------------------------------------
function d_getElementTop(elt, ignoreAbsolutePosition)
{
  var top = 0;
  if (elt != null && (elt.style.position != "absolute" && d_calculateStyleProperty(elt, "position") != "absolute" || ignoreAbsolutePosition)) {
    top = elt.offsetTop;
    if (d_isExplorer() || d_isOpera()) {
      var lowerCaseTagName = elt.tagName.toLowerCase();
      if (lowerCaseTagName == 'table') {
        if (elt.border > 0) {
          top ++;
        }
      } else if (lowerCaseTagName == 'div' || lowerCaseTagName == 'td') {
        top += elt.clientTop;
      }
    }
    if (elt.offsetParent) {
      var parentTop = d_getElementTop(elt.offsetParent, ignoreAbsolutePosition);
      top += parentTop;
    }
  }
  return top;
}
//------------------------------------------------------------------------------------------------------------------
function d_calculateStyleProperty(element, propertyName)
{
  var result;
  if (element.currentStyle) {
    var capitalizedProperty = d_capitalizeCssPropertyName(propertyName);
    result = element.currentStyle[capitalizedProperty];
  } else {
    var computedStyle = document.defaultView.getComputedStyle(element, "");
    if (computedStyle != null) {
      result = computedStyle.getPropertyValue(propertyName);
    }
  }
  if (!result)
    result = "";
  return result;
}
//------------------------------------------------------------------------------------------------------------------
function d_isExplorer()
{
  return d_checkBrowser("msie") && !d_checkBrowser("opera");
}
//------------------------------------------------------------------------------------------------------------------
function d_isOpera()
{
  return d_checkBrowser("opera");
}
//------------------------------------------------------------------------------------------------------------------
function d_capitalizeCssPropertyName(propertyName)
{
  while (true) {
    var idx = propertyName.indexOf("-");
    if (idx == -1)
      return propertyName;
    var firstPart = propertyName.substring(0, idx);
    var secondPart = propertyName.substring(idx + 1);
    if (secondPart.length > 0) {
      var firstChar = secondPart.substring(0, 1);
      firstChar = firstChar.toUpperCase();
      var otherChars = secondPart.substring(1);
      secondPart = firstChar + otherChars;
    }
    propertyName = firstPart + secondPart;
  }
  return propertyName;
}
//------------------------------------------------------------------------------------------------------------------
function d_checkBrowser(browserName)
{
  return navigator.userAgent.toLowerCase().indexOf(browserName.toLowerCase()) > -1;
}
//------------------------------------------------------------------------------------------------------------------
function q_showPopupLayerCentered(id)
{
	var w = document.body.clientWidth;
	var h = document.body.clientHeight;
	
	var element = d_getControl(id);
	var x = d_getElementLeft(element.parentNode, true) - d_getElementLeft(element.parentNode, false);
	var y = d_getElementTop(element.parentNode, true) - d_getElementTop(element.parentNode, false);
	q_showPopupLayerAtXY(id,
		-w,
		-h);
	var cw = element.clientWidth;
	var ch = element.clientHeight;
		
	q_setPopupLayerLeft(id, Math.round((w-cw)/2) - x);
	q_setPopupLayerTop(id, Math.round((h-ch)/2) - y);
}

function q_showPopupLayerCentered(id, targetId)
{
	var w = document.body.clientWidth;
	var h = document.body.clientHeight;
	
	var element = d_getControl(id);
	var x = d_getElementLeft(element.parentNode, true) - d_getElementLeft(element.parentNode, false);
	var y = d_getElementTop(element.parentNode, true) - d_getElementTop(element.parentNode, false);
	q_showPopupLayerAtXY(id,
		-w,
		-h);
	var cw = element.clientWidth;
	var ch = element.clientHeight;
	
	var yes = d_getControl(id + "_yes");
	var no = d_getControl(id + "_no");
	var targetYes = d_getControl(targetId + "_yes");
	var targetNo = d_getControl(targetId + "_no");

	yes.onclick = function(event)
	{
		q_hidePopupLayer(id);
		targetYes.click();
		window.setTimeout("document.getElementById('" + targetId + "_yes').click();", 1000);
		return false;
	};
	no.onclick = function()
	{
		alert(targetNo);
		targetNo.click();
		q_hidePopupLayer(id);
		return false;
	};
		
	q_setPopupLayerLeft(id, Math.round((w-cw)/2) - x);
	q_setPopupLayerTop(id, Math.round((h-ch)/2) - y);
}
