package org.jvnet.hifaces.text;

import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

public class RelativeText<T> extends AbstractSingularText {

	public static final String FALLBACK_MESSAGE_ID = "fallback.message";

	private final ValueBinding valueBinding;

	public RelativeText(final ValueBinding valueBinding) {
		this.valueBinding = valueBinding;
	}

	@SuppressWarnings("unchecked")
	protected String getMessageId(final FacesContext facesContext) {
		final T value = (T) valueBinding.getValue(facesContext);
		if (value != null) {
			return toString(value);
		} else {
			return null;
		}
	}

	protected String toString(T value) {
		return value.toString();
	}
}
