package org.jvnet.hifaces.user.binding;

import javax.faces.context.FacesContext;
import javax.faces.el.EvaluationException;
import javax.faces.el.PropertyNotFoundException;

import org.jvnet.hifaces.binding.BooleanValueBinding;

public class UserInRoleValueBinding extends BooleanValueBinding {

	private static final long serialVersionUID = 1L;

	private final String[] roles;

	public UserInRoleValueBinding(String role) {
		super();
		this.roles = new String[] { role };
	}

	public UserInRoleValueBinding(String... roles) {
		super();
		this.roles = roles;
	}

	public String[] getRoles() {
		return roles;
	}

	public Object getValue(FacesContext context) throws EvaluationException,
			PropertyNotFoundException {

		for (String role : getRoles()) {
			if (Boolean
					.valueOf(context.getExternalContext().isUserInRole(role)))
				return true;
		}
		return false;
	}
}
