package org.jvnet.hifaces.util;

import javax.faces.component.UIComponent;
import javax.faces.component.UIParameter;
import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

import org.jvnet.hifaces.function.Function0;

public class ParameterUtils {

	private ParameterUtils() {

	}

	public static UIParameter createParameter() {
		final UIParameter westParam = new UIParameter();
		IdUtils.assignId(westParam);
		return westParam;
	}

	public static UIParameter createParameter(String name) {
		final UIParameter param = createParameter();
		param.setName(name);
		return param;
	}

	public static UIParameter createParameter(String name, Object value) {
		final UIParameter param = createParameter(name);
		param.setValue(value);
		return param;
	}

	public static UIParameter createParameter(String name,
			ValueBinding valueBinding) {
		final UIParameter param = createParameter();
		param.setName(name);
		param.setValueBinding("value", valueBinding);
		return param;
	}

	public static UIParameter createIdParameter(String name,
			final UIComponent component) {
		final UIParameter param = createParameter(name, new IdFunction(
				component).asValueBinding());
		return param;
	}

	public static final class IdFunction extends Function0<String> {

		private static final long serialVersionUID = 1L;

		private final UIComponent component;

		private IdFunction(UIComponent component) {
			super(String.class);
			this.component = component;
		}

		@Override
		public String call() throws Exception {
			return component.getClientId(FacesContext.getCurrentInstance());
		}
	}

}
