package org.jvnet.hifaces.util;

import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;

import org.apache.myfaces.shared.util.MessageUtils;
import org.springframework.context.MessageSourceResolvable;

public class ResolveableMessageUtils {

	private ResolveableMessageUtils() {
	}

	public static void addMessage(FacesContext facesContext,
			String forClientId, FacesMessage.Severity severity,
			MessageSourceResolvable message) {
		final String[] codes = message.getCodes();
		final String code = codes[codes.length - 1];
		final Object[] arguments = message.getArguments();
		MessageUtils.addMessage(severity, code, arguments, forClientId,
				facesContext);
	}

	public static void addMessage(FacesContext facesContext,
			String forClientId, MessageSourceResolvable message) {

		addMessage(facesContext, forClientId, FacesMessage.SEVERITY_ERROR,
				message);

	}

	public static void addMessage(FacesContext facesContext,
			MessageSourceResolvable message) {

		addMessage(facesContext, null, message);

	}

	public static void addMessage(String forClientId,
			FacesMessage.Severity severity, MessageSourceResolvable message) {
		addMessage(FacesContext.getCurrentInstance(), forClientId, severity,
				message);
	}

	public static void addMessage(String forClientId,
			MessageSourceResolvable message) {

		addMessage(FacesContext.getCurrentInstance(), forClientId, message);
	}

	public static void addMessage(MessageSourceResolvable message) {

		addMessage(FacesContext.getCurrentInstance(), message);
	}
}
