package org.jvnet.hifaces.util;

import javax.faces.el.ValueBinding;

import org.apache.myfaces.custom.tabbedpane.HtmlPanelTab;
import org.apache.myfaces.custom.tabbedpane.HtmlPanelTabbedPane;
import org.jvnet.hifaces.text.Text;


public class TabbedPaneUtils {

  private TabbedPaneUtils() {
  }

  public static HtmlPanelTabbedPane createTabbedPane() {
    final HtmlPanelTabbedPane tabbedPane = new HtmlPanelTabbedPane();
    IdUtils.assignId(tabbedPane);
    tabbedPane.setBgcolor("transparent");
    return tabbedPane;
  }

  public static HtmlPanelTab createPanelTab() {
    final HtmlPanelTab tab = new HtmlPanelTab();
    IdUtils.assignId(tab);
    return tab;
  }
  public static HtmlPanelTab createPanelTab(String messageId) {
    final ValueBinding messageValueBinding = new Text(messageId);
    final HtmlPanelTab tab = createPanelTab(messageValueBinding);
    return tab;
  }

  public static HtmlPanelTab createPanelTab(final ValueBinding messageValueBinding) {
    final HtmlPanelTab tab = createPanelTab();
    tab.setValueBinding("label", messageValueBinding);
    return tab;
  }

}
