package org.jvnet.hifaces.util;

import java.util.TimeZone;

public class TimeZoneUtils {

	private TimeZoneUtils() {

	}

	// private String[] timeZoneIds = TimeZone.getAvailableIDs();
	public static String[] GMT_TIME_ZONE_IDS = { "GMT-12:00", "GMT-11:00",
			"GMT-10:00", "GMT-09:00", "GMT-08:00", "GMT-07:00", "GMT-06:00",
			"GMT-05:00", "GMT-04:00", "GMT-03:30", "GMT-03:00", "GMT-02:00",
			"GMT-01:00", "GMT", "GMT+01:00", "GMT+02:00", "GMT+03:00",
			"GMT+03:30", "GMT+04:00", "GMT+04:30", "GMT+05:00", "GMT+05:30",
			"GMT+05:45", "GMT+06:00", "GMT+06:30", "GMT+07:00", "GMT+08:00",
			"GMT+09:00", "GMT+09:30", "GMT+10:00", "GMT+11:00", "GMT+12:00",
			"GMT+13:00" };

	public static TimeZone[] GMT_TIME_ZONES;

	static {
		GMT_TIME_ZONES = new TimeZone[GMT_TIME_ZONE_IDS.length];
		for (int index = 0; index < GMT_TIME_ZONE_IDS.length; index++) {
			GMT_TIME_ZONES[index] = TimeZone
					.getTimeZone(GMT_TIME_ZONE_IDS[index]);
		}
	}

	public static TimeZone getGMTTimeZone(TimeZone tz) {
		for (final TimeZone timeZone : GMT_TIME_ZONES) {
			if (timeZone.getID().equals(tz.getID())
					|| tz.getRawOffset() == timeZone.getRawOffset()) {
				return timeZone;
			}
		}
		return tz;
	}

	public static TimeZone getDefaultGMTTimeZone() {
		return getGMTTimeZone(TimeZone.getDefault());
	}

}
